<template>
  <BasicLayout>
    <template #wrapper>
      <el-card class="box-card">
        <el-form ref="queryForm" :model="queryParams" :inline="true" label-width="68px">
          <el-form-item label="钱包私钥" prop="privateKey"><el-input
            v-model="queryParams.privateKey"
            placeholder="请输入钱包私钥"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
          </el-form-item>

          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:wmWalletInfo:add']"
              type="primary"
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
            >批量添加
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:wmWalletInfo:upload']"
              type="primary"
              icon="el-icon-plus"
              size="mini"
              @click="handleUploadExcel"
            >导入钱包
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:wmWalletInfo:edit']"
              type="primary"
              icon="el-icon-edit"
              size="mini"
              :disabled="multiple"
              @click="handleUpdate"
            >修改备注
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:wmWalletInfo:remove']"
              type="danger"
              icon="el-icon-delete"
              size="mini"
              :disabled="multiple"
              @click="handleDelete"
            >删除
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:wmWalletInfo:clearAll']"
              type="danger"
              icon="el-icon-delete"
              size="mini"
              @click="handleClearAll"
            >清除所有
            </el-button>
          </el-col>
        </el-row>

        <el-table v-loading="loading" :data="wmWalletInfoList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="55" align="center" />
          <el-table-column label="编号" prop="id" align="center" width="55" />
          <el-table-column label="钱包私钥" align="center" prop="privateKey" :show-overflow-tooltip="true" />
          <el-table-column label="钱包地址" align="center" prop="address" />
          <el-table-column label="备注" prop="remark" :show-overflow-tooltip="true" />
          <el-table-column label="创建时间" prop="createdAt" width="155">
            <template slot-scope="scope">
              <span>{{ parseTime(scope.row.createdAt) }}</span>
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="150">
            <template slot-scope="scope">
              <el-button
                slot="reference"
                v-permisaction="['admin:wmWalletInfo:edit']"
                size="mini"
                type="text"
                icon="el-icon-delete"
                @click="handleUpdate(scope.row)"
              >编辑
              </el-button>
              <el-button
                slot="reference"
                v-permisaction="['admin:wmWalletInfo:remove']"
                size="mini"
                type="text"
                icon="el-icon-delete"
                @click="handleDelete(scope.row)"
              >删除
              </el-button>
            </template>
          </el-table-column>
        </el-table>

        <pagination
          v-show="total > 0"
          :total="total"
          :page.sync="queryParams.pageIndex"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />

        <!-- 添加或修改对话框 -->
        <el-dialog :title="title" :visible.sync="open" width="500px">
          <el-form ref="form" :model="form" :rules="rules" label-width="80px">
            <el-form-item label="钱包私钥" prop="keys">
              <el-input
                v-model="form.keys"
                placeholder="钱包私钥 用,或换行分隔"
                type="textarea"
                :rows="3"
                clearable
              />
            </el-form-item>
          </el-form>
          <div slot="footer" class="dialog-footer">
            <el-button type="primary" :loading="loading" @click="submitForm">确 定</el-button>
            <el-button @click="cancel">取 消</el-button>
          </div>
        </el-dialog>

        <el-dialog title="修改备注" :visible.sync="remarkOpen" width="500px">
          <el-form ref="remarkForm" :model="remarkForm" label-width="80px">
            <el-form-item label="备注" prop="remark">
              <el-input
                v-model="remarkForm.remark"
                placeholder="请填写备注"
                type="textarea"
                :rows="3"
                clearable
                maxlength="255"
                show-word-limit
              />
            </el-form-item>
          </el-form>
          <div slot="footer" class="dialog-footer">
            <el-button type="primary" :loading="loading" @click="submitRemarkForm">确 定</el-button>
            <el-button @click="cancel">取 消</el-button>
          </div>
        </el-dialog>

        <ExcelImport :show.sync="fileOpen" @upload-success="handleExcelSuccess" />
      </el-card>
    </template>
  </BasicLayout>
</template>

<script>
import { addWmWalletInfo, delWmWalletInfo, listWmWalletInfo, clearAllWmWalletInfo, batchUpdateWmWalletInfo } from '@/api/admin/wm-wallet-info'
import ExcelImport from '@/views/admin/wm-wallet-info/excel-import'

export default {
  name: 'WmWalletInfo',
  components: {
    ExcelImport
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      remarkOpen: false,
      isEdit: false,
      fileOpen: false,
      // 类型数据字典
      typeOptions: [],
      wmWalletInfoList: [],

      // 关系表类型

      // 查询参数
      queryParams: {
        pageIndex: 1,
        pageSize: 10,
        privateKey: undefined,
        idOrder: 'desc'
      },
      // 表单参数
      form: {
      },
      remarkForm: {},
      // 表单校验
      rules: {
        keys: [{ required: true, message: '钱包私钥不能为空', trigger: 'blur' }]
      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    /** 查询参数列表 */
    getList() {
      this.loading = true
      listWmWalletInfo(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
        this.wmWalletInfoList = response.data.list
        this.total = response.data.count
        this.loading = false
      }
      )
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.remarkOpen = false
      this.reset()
      this.resetRemarkForm()
    },
    resetRemarkForm() {
      this.remarkForm = {
        ids: undefined,
        remark: undefined
      }
    },
    // 表单重置
    reset() {
      this.form = {

        id: undefined,
        privateKey: undefined,
        address: undefined
      }
      this.resetForm('form')
    },
    getImgList: function() {
      this.form[this.fileIndex] = this.$refs['fileChoose'].resultList[0].fullUrl
    },
    fileClose: function() {
      this.fileOpen = false
    },
    // 关系
    // 文件
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageIndex = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = []
      this.resetForm('queryForm')
      this.handleQuery()
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加钱包信息'
      this.isEdit = false
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.resetRemarkForm()
      const id =
                row.id ? [row.id] : this.ids
      this.remarkForm.ids = id
      this.remarkOpen = true
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          this.loading = true
          addWmWalletInfo(this.form).then(response => {
            if (response.code === 200) {
              this.msgSuccess(response.msg)
              this.open = false
              this.getList()
            } else {
              this.msgError(response.msg)
            }
          })
            .finally(() => {
              this.loading = false
            })
        }
      })
    },
    submitRemarkForm: function() {
      this.$refs['remarkForm'].validate(valid => {
        if (valid) {
          this.loading = true
          batchUpdateWmWalletInfo(this.remarkForm).then(response => {
            if (response.code === 200) {
              this.msgSuccess(response.msg)
              this.remarkOpen = false
              this.getList()
            } else {
              this.msgError(response.msg)
            }
          })
            .finally(() => {
              this.loading = false
            })
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      var Ids = (row.id && [row.id]) || this.ids

      this.$confirm('是否确认删除编号为"' + Ids + '"的数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        return delWmWalletInfo({ 'ids': Ids })
      }).then((response) => {
        if (response.code === 200) {
          this.msgSuccess(response.msg)
          this.open = false
          this.getList()
        } else {
          this.msgError(response.msg)
        }
      }).catch(function() {
      })
        .finally(() => {
          this.loading = false
        })
    },
    handleClearAll() {
      const _this = this

      this.$confirm('是否确认清除所有钱包信息?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        _this.loading = true
        return clearAllWmWalletInfo()
      }).then((response) => {
        if (response.code === 200) {
          _this.msgSuccess(response.msg)
          _this.getList()
        } else {
          _this.msgError(response.msg)
        }
      }).catch(function() {
      })
        .finally(() => {
          _this.loading = false
        })
    },
    handleExcelSuccess() {
      this.getList()
    },
    handleUploadExcel() {
      console.log('上传文件')
      this.fileOpen = true
    }
  }
}
</script>
